Index: sasmodels/models/correlation_length.py
===================================================================
--- sasmodels/models/correlation_length.py	(revision 5054e805a7c53aa18f659a0c1613f527f05caab3)
+++ sasmodels/models/correlation_length.py	(revision 5054e805a7c53aa18f659a0c1613f527f05caab3)
@@ -0,0 +1,92 @@
+#correlation length model
+# Note: model title and parameter table are inserted automatically
+r"""
+Definition
+----------
+
+The scattering intensity I(q) is calculated as
+
+.. math::
+    I(Q) = \frac{A}{Q^n} + \frac{C}{1 + (Q\xi)^m} + B
+
+The first term describes Porod scattering from clusters (exponent = n) and the
+second term is a Lorentzian function describing scattering from polymer chains
+(exponent = m). This second term characterizes the polymer/solvent interactions
+and therefore the thermodynamics. The two multiplicative factors A and C, the
+incoherent background B and the two exponents n and m are used as fitting
+parameters. The final parameter &xi; is a correlation length for the polymer
+chains. Note that when m=2 this functional form becomes the familiar Lorentzian
+function.
+
+For 2D data: The 2D scattering intensity is calculated in the same way as 1D,
+where the q vector is defined as
+
+.. math::
+    q = \sqrt{q_x^2 + q_y^2}
+
+.. figure:: img/correlation_length_1d.jpg
+
+    1D plot using the default values (w/500 data points).
+
+REFERENCE
+B Hammouda, D L Ho and S R Kline, Insight into Clustering in
+Poly(ethylene oxide) Solutions, Macromolecules, 37 (2004) 6932-6937
+"""
+
+from numpy import inf, sqrt
+
+name = "correlation_length"
+title = """Calculates an empirical functional form for SAS data characterized
+by a low-Q signal and a high-Q signal."""
+description = """
+"""
+category = "shape-independent"
+# pylint: disable=bad-continuation, line-too-long
+#             ["name", "units", default, [lower, upper], "type","description"],
+parameters = [
+              ["lorentz_scale", "", 10.0, [0, inf], "", "Lorentzian Scaling Factor"],
+              ["porod_scale", "", 1e-06, [0, inf], "", "Porod Scaling Factor"],
+              ["cor_length", "Ang", 50.0, [0, inf], "", "Correlation length"],
+              ["exponent_p", "", 3.0, [0, inf], "", "Porod Exponent"],
+              ["exponent_l", "1/Ang^2", 2.0, [0, inf], "", "Lorentzian Exponent"],
+             ]
+# pylint: enable=bad-continuation, line-too-long
+
+def Iq(q, lorentz_scale, porod_scale, cor_length, exponent_p, exponent_l):
+    """
+    1D calculation of the Correlation length model
+    """
+    porod = porod_scale / pow(q, exponent_p)
+    lorentz = lorentz_scale / (1.0 + pow(q * cor_length, exponent_l))
+    inten = porod + lorentz
+    return inten
+
+def Iqxy(qx, qy, lorentz_scale, porod_scale, cor_length, exponent_p, exponent_l):
+    """
+    2D calculation of the Correlation length model
+    There is no orientation contribution.
+    """
+    q = sqrt(qx ** 2 + qy ** 2)
+    return Iq(q, lorentz_scale, porod_scale, cor_length, exponent_p, exponent_l)
+
+# parameters for demo
+demo = dict(lorentz_scale=10.0, porod_scale=1.0e-06, cor_length=50.0,
+            exponent_p=3.0, exponent_l=2.0, background=0.1,
+           )
+
+# For testing against the old sasview models, include the converted parameter
+# names and the target sasview model name.
+oldname = 'CorrLengthModel'
+# pylint: disable=bad-continuation
+oldpars = dict(
+               lorentz_scale='scale_l', porod_scale='scale_p',
+               cor_length='length_l', exponent_p='exponent_p',
+               exponent_l='exponent_l'
+               )
+
+tests = [
+         [{}, 0.001, 1009.98],
+         [{}, 0.150141, 0.174645],
+         [{}, 0.442528, 0.0203957]
+         ]
+# pylint: enable=bad-continuation
Index: sasmodels/models/fcc.c
===================================================================
--- sasmodels/models/fcc.c	(revision 82d239a5cb4d8005a4b04bf42b1425792a28383d)
+++ sasmodels/models/fcc.c	(revision eeb8bacf06af69341f80d5e76d7b10a7239c4e67)
@@ -101,5 +101,5 @@
 
   double b3_x, b3_y, b1_x, b1_y, b2_x, b2_y; //b3_z,
-  double q_z;
+  // double q_z;
   double cos_val_b3, cos_val_b2, cos_val_b1;
   double a1_dot_q, a2_dot_q,a3_dot_q;
@@ -124,5 +124,5 @@
   const double latticescale = 2.0*(4.0/3.0)*M_PI*(radius*radius*radius)/(s1*s1*s1);
   // q vector
-  q_z = 0.0; // for SANS; assuming qz is negligible
+  // q_z = 0.0; // for SANS; assuming qz is negligible
   /// Angles here are respect to detector coordinate
   ///  instead of against q coordinate(PRB 36(46), 3(6), 1754(3854))
Index: sasmodels/models/fcc.py
===================================================================
--- sasmodels/models/fcc.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/fcc.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -112,4 +112,6 @@
 category = "shape:paracrystal"
 
+single = False
+
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["dnn", "Ang", 220, [-inf, inf], "", "Nearest neighbour distance"],
Index: sasmodels/models/flexible_cylinder.c
===================================================================
--- sasmodels/models/flexible_cylinder.c	(revision f94d8a27ee285627fab8769c64a054dbc75e774f)
+++ sasmodels/models/flexible_cylinder.c	(revision f94d8a27ee285627fab8769c64a054dbc75e774f)
@@ -0,0 +1,64 @@
+double form_volume(double length, double kuhn_length, double radius);
+double Iq(double q, double length, double kuhn_length, double radius,
+          double sld, double solvent_sld);
+double Iqxy(double qx, double qy, double length, double kuhn_length,
+            double radius, double sld, double solvent_sld);
+double flexible_cylinder_kernel(double q, double length, double kuhn_length,
+                                double radius, double sld, double solvent_sld);
+
+
+double form_volume(double length, double kuhn_length, double radius)
+{
+
+      return 0.0;
+}
+
+double flexible_cylinder_kernel(double q,
+          double length,
+          double kuhn_length,
+          double radius,
+          double sld,
+          double solvent_sld)
+{
+
+	double Pi = 4.0*atan(1.0);
+
+	double cont = sld-solvent_sld;
+	double qr = q*radius;
+	double flex = Sk_WR(q,length,kuhn_length);
+    double crossSect = (2.0*J1(qr)/qr)*(2.0*J1(qr)/qr);
+
+	flex *= crossSect;
+	flex *= Pi*radius*radius*length;
+	flex *= cont*cont;
+	flex *= 1.0e-4;
+
+	return flex;
+}
+
+double Iq(double q,
+          double length,
+          double kuhn_length,
+          double radius,
+          double sld,
+          double solvent_sld)
+{
+
+	double result = flexible_cylinder_kernel(q, length, kuhn_length, radius, sld, solvent_sld);
+
+	return result;
+}
+
+double Iqxy(double qx, double qy,
+            double length,
+            double kuhn_length,
+            double radius,
+            double sld,
+            double solvent_sld)
+{
+	double q;
+	q = sqrt(qx*qx+qy*qy);
+	double result = flexible_cylinder_kernel(q, length, kuhn_length, radius, sld, solvent_sld);
+
+	return result;
+}
Index: sasmodels/models/flexible_cylinder.py
===================================================================
--- sasmodels/models/flexible_cylinder.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
+++ sasmodels/models/flexible_cylinder.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -0,0 +1,139 @@
+r"""
+This model provides the form factor, $P(q)$, for a flexible cylinder
+where the form factor is normalized by the volume of the cylinder.
+**Inter-cylinder interactions are NOT provided for.**
+
+.. math::
+
+    P(q) = \text{scale} \left<F^2\right>/V + \text{background}
+
+where the averaging $\left<\ldots\right>$ is applied only for the 1D
+calculation
+
+The 2D scattering intensity is the same as 1D, regardless of the orientation of
+the q vector which is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+Definitions
+-----------
+
+.. figure:: img/flexible_cylinder_geometry.jpg
+
+
+The chain of contour length, $L$, (the total length) can be described as a
+chain of some number of locally stiff segments of length $l_p$, the persistence
+length (the length along the cylinder over which the flexible cylinder can be
+considered a rigid rod).
+The Kuhn length $(b = 2*l_p)$ is also used to describe the stiffness of a chain.
+
+The returned value is in units of $cm^-1$, on absolute scale.
+
+In the parameters, the sldCyl and sldSolv represent the SLD of the chain/cylinder
+and solvent respectively.
+
+
+.. figure:: img/flexible_cylinder_1d.jpg
+
+    1D plot using the default values (w/1000 data point).
+
+
+Our model uses the form factor calculations implemented in a c-library provided
+by the NIST Center for Neutron Research (Kline, 2006).
+
+
+From the reference:
+
+    'Method 3 With Excluded Volume' is used.
+    The model is a parametrization of simulations of a discrete representation
+    of the worm-like chain model of Kratky and Porod applied in the
+    pseudocontinuous limit.
+    See equations (13,26-27) in the original reference for the details.
+
+References
+----------
+
+J S Pedersen and P Schurtenberger. *Scattering functions of semiflexible
+polymers with and without excluded volume effects.* Macromolecules,
+29 (1996) 7602-7612
+
+Correction of the formula can be found in
+
+W R Chen, P D Butler and L J Magid, *Incorporating Intermicellar Interactions
+in the Fitting of SANS Data from Cationic Wormlike Micelles.* Langmuir,
+22(15) 2006 6539-6548
+"""
+from numpy import inf
+
+name = "flexible_cylinder"
+title = "Flexible cylinder where the form factor is normalized by the volume" \
+        "of the cylinder."
+description = """Note : scale and contrast=sld-solvent_sld are both
+                multiplicative factors in the model and are perfectly
+                correlated. One or both of these parameters must be held fixed
+                during model fitting.
+              """
+
+category = "shape:cylinder"
+single = False
+
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["length",      "Ang",       1000.0, [0, inf],    "volume", "Length of the flexible cylinder"],
+    ["kuhn_length", "Ang",        100.0, [0, inf],    "volume", "Kuhn length of the flexible cylinder"],
+    ["radius",      "Ang",         20.0, [0, inf],    "volume", "Radius of the flexible cylinder"],
+    ["sld",         "1e-6/Ang^2",   1.0, [-inf, inf], "",       "Cylinder scattering length density"],
+    ["solvent_sld", "1e-6/Ang^2",   6.3, [-inf, inf], "",       "Solvent scattering length density"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+source = ["lib/J1.c", "lib/wrc_cyl.c", "flexible_cylinder.c"]
+
+demo = dict(scale=1.0, background=0.0001,
+            length=1000.0,
+            kuhn_length=100.0,
+            radius=20.0,
+            sld=1.0,
+            solvent_sld=6.3)
+
+oldname = 'FlexibleCylinderModel'
+oldpars = dict(sld='sldCyl', solvent_sld='sldSolv')
+
+
+tests = [
+    # Accuracy tests based on content in test/utest_other_models.py
+    # Currently fails in OCL
+    # [{'length':     1000.0,
+    #  'kuhn_length': 100.0,
+    #  'radius':       20.0,
+    #  'sld':           1.0,
+    #  'solvent_sld':   6.3,
+    #  'background':    0.0001,
+    #  }, 0.001, 3509.2187],
+
+    # Additional tests with larger range of parameters
+    [{'length':    1000.0,
+      'kuhn_length': 100.0,
+      'radius':       20.0,
+      'sld':           1.0,
+      'solvent_sld':   6.3,
+      'background':    0.0001,
+     }, 1.0, 0.000595345],
+    [{'length':        10.0,
+      'kuhn_length': 800.0,
+      'radius':        2.0,
+      'sld':           6.0,
+      'solvent_sld':  12.3,
+      'background':    0.001,
+     }, 0.1, 1.55228],
+    [{'length':        100.0,
+      'kuhn_length': 800.0,
+      'radius':       50.0,
+      'sld':           0.1,
+      'solvent_sld':   5.1,
+      'background':    0.0,
+     }, 1.0, 0.000938456]
+    ]
+
Index: sasmodels/models/flexible_cylinder_ex.c
===================================================================
--- sasmodels/models/flexible_cylinder_ex.c	(revision 504abeee8bc5d67a14d7598227542961d3d748ed)
+++ sasmodels/models/flexible_cylinder_ex.c	(revision 504abeee8bc5d67a14d7598227542961d3d748ed)
@@ -0,0 +1,103 @@
+double form_volume(double length, double kuhn_length, double radius);
+double Iq(double q, double length, double kuhn_length, double radius,
+          double axis_ratio, double sld, double solvent_sld);
+double Iqxy(double qx, double qy, double length, double kuhn_length,
+            double radius, double axis_ratio, double sld, double solvent_sld);
+double flexible_cylinder_ex_kernel(double q, double length, double kuhn_length,
+                                double radius, double axis_ratio, double sld,
+                                double solvent_sld);
+double elliptical_crosssection(double q, double a, double b);
+
+double form_volume(double length, double kuhn_length, double radius)
+{
+    return 1.0;
+}
+
+double
+elliptical_crosssection(double q, double a, double b)
+{
+    double uplim,lolim,Pi,summ,arg,zi,yyy,answer;
+    int i,nord=76;
+
+    Pi = 4.0*atan(1.0);
+    lolim=0.0;
+    uplim=Pi/2.0;
+    summ=0.0;
+
+    for(i=0;i<nord;i++) {
+		zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
+		arg = q*sqrt(a*a*sin(zi)*sin(zi)+b*b*cos(zi)*cos(zi));
+		yyy = pow((2.0 * J1(arg) / arg),2);
+		yyy *= Gauss76Wt[i];
+		summ += yyy;
+    }
+    answer = (uplim-lolim)/2.0*summ;
+    answer *= 2.0/Pi;
+    return(answer);
+
+}
+
+double flexible_cylinder_ex_kernel(double q,
+          double length,
+          double kuhn_length,
+          double radius,
+          double axis_ratio,
+          double sld,
+          double solvent_sld)
+{
+
+	double Pi,flex,crossSect, cont;
+
+	Pi = 4.0*atan(1.0);
+	cont = sld - solvent_sld;
+	crossSect = elliptical_crosssection(q,radius,(radius*axis_ratio));
+
+	flex = Sk_WR(q,length,kuhn_length);
+	flex *= crossSect;
+	flex *= Pi*radius*radius*axis_ratio*axis_ratio*length;
+	flex *= cont*cont;
+	flex *= 1.0e-4;
+
+	return flex;
+}
+
+double Iq(double q,
+          double length,
+          double kuhn_length,
+          double radius,
+          double axis_ratio,
+          double sld,
+          double solvent_sld)
+{
+
+	double result = flexible_cylinder_ex_kernel(q,
+	                length,
+	                kuhn_length,
+	                radius,
+	                axis_ratio,
+	                sld,
+	                solvent_sld);
+
+	return result;
+}
+
+double Iqxy(double qx, double qy,
+            double length,
+            double kuhn_length,
+            double radius,
+            double axis_ratio,
+            double sld,
+            double solvent_sld)
+{
+	double q;
+	q = sqrt(qx*qx+qy*qy);
+	double result = flexible_cylinder_ex_kernel(q,
+	                length,
+	                kuhn_length,
+	                radius,
+	                axis_ratio,
+	                sld,
+	                solvent_sld);
+
+	return result;
+}
Index: sasmodels/models/flexible_cylinder_ex.py
===================================================================
--- sasmodels/models/flexible_cylinder_ex.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
+++ sasmodels/models/flexible_cylinder_ex.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -0,0 +1,167 @@
+r"""
+This model calculates the form factor for a flexible cylinder with an
+elliptical cross section and a uniform scattering length density.
+The non-negligible diameter of the cylinder is included by accounting
+for excluded volume interactions within the walk of a single cylinder.
+The form factor is normalized by the particle volume such that
+
+.. math::
+
+    P(q) = \text{scale} \left<F^2\right>/V + \text{background}
+
+where the averaging $\left<\ldots\right>$ is over all possible orientations
+of the flexible cylinder.
+
+The 2D scattering intensity is the same as 1D, regardless of the orientation
+of the q vector which is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+Definitions
+-----------
+
+The function calculated is from the reference given below. From that paper,
+"Method 3 With Excluded Volume" is used.
+The model is a parameterization of simulations of a discrete representation of
+the worm-like chain model of Kratky and Porod applied in the pseudo-continuous
+limit. See equations (13, 26-27) in the original reference for the details.
+
+.. note::
+
+    There are several typos in the original reference that have been corrected
+    by WRC. Details of the corrections are in the reference below. Most notably
+
+    - Equation (13): the term $(1 - w(QR))$ should swap position with $w(QR)$
+
+    - Equations (23) and (24) are incorrect; WRC has entered these into
+      Mathematica and solved analytically. The results were then converted to
+      code.
+
+    - Equation (27) should be $q0 = max(a3/sqrt(RgSquare),3)$ instead of
+      $max(a3*b/sqrt(RgSquare),3)$
+
+    - The scattering function is negative for a range of parameter values and
+      q-values that are experimentally accessible. A correction function has been
+      added to give the proper behavior.
+
+.. figure:: img/flexible_cylinder_ex_geometry.jpg
+
+
+The chain of contour length, $L$, (the total length) can be described as a chain
+of some number of locally stiff segments of length $l_p$, the persistence length
+(the length along the cylinder over which the flexible cylinder can be considered
+a rigid rod).
+The Kuhn length $(b = 2*l_p)$ is also used to describe the stiffness of a chain.
+
+The cross section of the cylinder is elliptical, with minor radius $a$ .
+The major radius is larger, so of course, **the axis ratio (parameter 5) must be
+greater than one.** Simple constraints should be applied during curve fitting to
+maintain this inequality.
+
+The returned value is in units of $cm^-1$, on absolute scale.
+
+In the parameters, the $sldCyl$ and $sldSolv$ represent the SLD of the
+chain/cylinder and solvent respectively. The *scale*, and the contrast are both
+multiplicative factors in the model and are perfectly correlated. One or both of
+these parameters must be held fixed during model fitting.
+
+**No inter-cylinder interference effects are included in this calculation.**
+
+.. figure:: img/flexible_cylinder_ex_1d.jpg
+
+    1D plot using the default values (w/1000 data point).
+
+References
+----------
+
+J S Pedersen and P Schurtenberger. *Scattering functions of semiflexible polymers
+with and without excluded volume effects.* Macromolecules, 29 (1996) 7602-7612
+
+Correction of the formula can be found in
+
+W R Chen, P D Butler and L J Magid, *Incorporating Intermicellar Interactions in
+the Fitting of SANS Data from Cationic Wormlike Micelles.* Langmuir,
+22(15) 2006 6539-6548
+"""
+from numpy import inf
+
+name = "flexible_cylinder_ex"
+title = "Flexible cylinder wth an elliptical cross section and a uniform " \
+        "scattering length density."
+description = """Note : scale and contrast=sldCyl-sldSolv are both multiplicative
+        factors in the
+        model and are perfectly correlated. One or
+        both of these parameters must be held fixed
+        during model fitting.
+        """
+single = False
+
+category = "shape:cylinder"
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["length",      "Ang",       1000.0, [0, inf],    "volume", "Length of the flexible cylinder"],
+    ["kuhn_length", "Ang",        100.0, [0, inf],    "volume", "Kuhn length of the flexible cylinder"],
+    ["radius",      "Ang",         20.0, [0, inf],    "volume", "Radius of the flexible cylinder"],
+    ["axis_ratio",  "",             1.5, [0, inf],    "",       "Axis_ratio (major_radius/radius"],
+    ["sld",         "1e-6/Ang^2",   1.0, [-inf, inf], "",       "Cylinder scattering length density"],
+    ["solvent_sld", "1e-6/Ang^2",   6.3, [-inf, inf], "",       "Solvent scattering length density"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lib/J1.c", "lib/gauss76.c", "lib/wrc_cyl.c", "flexible_cylinder_ex.c"]
+
+demo = dict(scale=1.0, background=0.0001,
+            length=1000.0,
+            kuhn_length=100.0,
+            radius=20.0,
+            axis_ratio=1.5,
+            sld=1.0,
+            solvent_sld=6.3)
+
+oldname = 'FlexCylEllipXModel'
+oldpars = dict(sld='sldCyl', solvent_sld='sldSolv')
+
+
+tests = [
+    # Accuracy tests based on content in test/utest_other_models.py
+    # Currently fails in OCL
+    # [{'length':     1000.0,
+    #  'kuhn_length': 100.0,
+    #  'radius':       20.0,
+    #  'axis_ratio':    1.5,
+    #  'sld':           1.0,
+    #  'solvent_sld':   6.3,
+    #  'background':    0.0001,
+    # }, 0.001, 3509.2187],
+
+    # Additional tests with larger range of parameters
+    [{'length':     1000.0,
+      'kuhn_length': 100.0,
+      'radius':       20.0,
+      'axis_ratio':    1.5,
+      'sld':           1.0,
+      'solvent_sld':   6.3,
+      'background':    0.0001,
+     }, 1.0, 0.00223819],
+    [{'length':        10.0,
+      'kuhn_length': 800.0,
+      'radius':        2.0,
+      'axis_ratio':    0.5,
+      'sld':           6.0,
+      'solvent_sld':  12.3,
+      'background':    0.001,
+     }, 0.1, 0.390281],
+    [{'length':        100.0,
+      'kuhn_length': 800.0,
+      'radius':       50.0,
+      'axis_ratio':    4.5,
+      'sld':           0.1,
+      'solvent_sld':   5.1,
+      'background':    0.0,
+     }, 1.0, 0.0016338264790]
+    ]
+
Index: sasmodels/models/gauss_lorentz_gel.py
===================================================================
--- sasmodels/models/gauss_lorentz_gel.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
+++ sasmodels/models/gauss_lorentz_gel.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
@@ -0,0 +1,167 @@
+r"""
+This model calculates the scattering from a gel structure,
+but typically a physical rather than chemical network.
+It is modeled as a sum of a low-q exponential decay plus
+a lorentzian at higher-q values.
+
+Definition
+----------
+
+The scattering intensity I(q) is calculated as (Eqn. 5 from the reference)
+
+.. math::
+
+    I(q) = I_G(0)exp(-q^2\Xi ^2/2) + I_L(0)/(1+q^2\xi^2)
+
+$\Xi$ is the length scale of the static correlations in the gel,
+which can be attributed to the "frozen-in" crosslinks.
+$\xi is the dynamic correlation length, which can be attributed to the
+fluctuating polymer chains between crosslinks.
+$IG(0)$ and $IL(0)$ are the scaling factors for each of these structures.
+Think carefully about how these map to your particular system!
+
+.. note::
+    The peaked structure at higher $q$ values (Figure 2 from the reference)
+    is not reproduced by the model. Peaks can be introduced into the model
+    by summing this model with the PeakGaussModel function.
+
+For 2D data the scattering intensity is calculated in the same way as 1D,
+where the $q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+.. figure:: img/gauss_lorentz_gel_1d.jpg
+
+    1D plot using the default values (w/500 data point).
+
+
+References
+----------
+
+G Evmenenko, E Theunissen, K Mortensen, H Reynaers, *Polymer*,
+42 (2001) 2907-2913
+
+"""
+
+from numpy import inf, sqrt, exp
+
+name = "gauss_lorentz_gel"
+title = "Gauss Lorentz Gel model of scattering from a gel structure"
+description = """
+            Class that evaluates a GaussLorentzGel model.
+
+            I(q) = scale_g*exp(- q^2*Z^2 / 2)+scale_l/(1+q^2*z^2)
+                    + background
+            List of default parameters:
+                scale_g = Gauss scale factor
+                Z = Static correlation length
+                scale_l = Lorentzian scale factor
+                z = Dynamic correlation length
+                background = Incoherent background
+            """
+category = "shape-independent"
+# pylint: disable=bad-whitespace, line-too-long
+#            ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["gauss_scale_factor",   "",    100.0,  [-inf, inf], "", "Gauss scale factor"],
+              ["static_cor_length",    "Ang", 100.0,  [0, inf],    "", "Static correlation length"],
+              ["lorentz_scale_factor", "",     50.0,  [-inf, inf], "", "Lorentzian scale factor"],
+              ["dynamic_cor_length",   "Ang",  20.0,  [0, inf],    "", "Dynamic correlation length"],
+             ]
+# pylint: enable=bad-whitespace, line-too-long
+
+def Iq(q,
+       gauss_scale_factor=100.0,
+       static_cor_length=100.0,
+       lorentz_scale_factor=50.0,
+       dynamic_cor_length=20.0):
+    """
+
+    :param q:                    Input q-value
+    :param gauss_scale_factor:   Gauss scale factor
+    :param static_cor_length:    Static correlation length
+    :param lorentz_scale_factor: Lorentzian scale factor
+    :param dynamic_cor_length:   Dynamic correlation length
+    :return:                     1-D intensity
+    """
+
+    term1 = gauss_scale_factor *\
+            exp(-1.0*q*q*static_cor_length*static_cor_length/2.0)
+    term2 = lorentz_scale_factor /\
+            (1.0+(q*dynamic_cor_length)*(q*dynamic_cor_length))
+
+    return term1 + term2
+
+Iq.vectorized = True  # Iq accepts an array of q values
+
+
+def Iqxy(qx, qy, *args):
+    """
+    :param qx:   Input q_x-value
+    :param qy:   Input q_y-value
+    :param args: Remaining aruments
+    :return:     2-D intensity
+    """
+
+    return Iq(sqrt(qx**2 + qy**2), *args)
+
+Iqxy.vectorized = True  # Iqxy accepts an array of qx, qy values
+
+
+demo = dict(scale=1, background=0.1,
+            gauss_scale_factor=100.0,
+            static_cor_length=100.0,
+            lorentz_scale_factor=50.0,
+            dynamic_cor_length=20.0)
+
+oldname = "GaussLorentzGelModel"
+
+oldpars = dict(background='background',
+               gauss_scale_factor='scale_g',
+               static_cor_length='stat_colength',
+               lorentz_scale_factor='scale_l',
+               dynamic_cor_length='dyn_colength')
+
+tests = [
+
+    # Accuracy tests based on content in test/utest_extra_models.py
+    [{'gauss_scale_factor':  100.0,
+      'static_cor_length':   100.0,
+      'lorentz_scale_factor': 50.0,
+      'dynamic_cor_length':   20.0,
+     }, 0.001, 149.481],
+
+    [{'gauss_scale_factor':  100.0,
+      'static_cor_length':   100.0,
+      'lorentz_scale_factor': 50.0,
+      'dynamic_cor_length':   20.0,
+     }, 0.105363, 9.1903],
+
+    [{'gauss_scale_factor':  100.0,
+      'static_cor_length':   100.0,
+      'lorentz_scale_factor': 50.0,
+      'dynamic_cor_length':   20.0,
+     }, 0.441623, 0.632811],
+
+    # Additional tests with larger range of parameters
+    [{'gauss_scale_factor':  10.0,
+      'static_cor_length':  100.0,
+      'lorentz_scale_factor': 3.0,
+      'dynamic_cor_length':   1.0,
+     }, 0.1, 2.9702970297],
+
+    [{'gauss_scale_factor':  10.0,
+      'static_cor_length':  100.0,
+      'lorentz_scale_factor': 3.0,
+      'dynamic_cor_length':   1.0,
+      'background':         100.0
+     }, 5.0, 100.115384615],
+
+    [{'gauss_scale_factor':  10.0,
+      'static_cor_length':  100.0,
+      'lorentz_scale_factor': 3.0,
+      'dynamic_cor_length':   1.0,
+     }, 200., 7.49981250469e-05],
+    ]
Index: sasmodels/models/gaussian_peak.py
===================================================================
--- sasmodels/models/gaussian_peak.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/gaussian_peak.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -42,4 +42,5 @@
 category = "shape-independent"
 
+single = False
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["q0", "1/Ang", 0.05, [-inf, inf], "", "Peak position"],
Index: sasmodels/models/gel_fit.py
===================================================================
--- sasmodels/models/gel_fit.py	(revision 513efc509d218370e6a8ca9cabf24f087a2de902)
+++ sasmodels/models/gel_fit.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
@@ -7,6 +7,6 @@
 in the position of the polymer chains that ensure thermodynamic equilibrium,
 and a longer distance (denoted here as $a2$ ) needed to account for the static
-accumulations of polymer pinned down by junction points or clusters of such points.
-The latter is derived from a simple Guinier function.
+accumulations of polymer pinned down by junction points or clusters of such
+points. The latter is derived from a simple Guinier function.
 
 
@@ -40,9 +40,9 @@
 ---------
 
-Mitsuhiro Shibayama, Toyoichi Tanaka, Charles C Han, J. Chem. Phys. 1992, 97 (9),
-6829-6841
+Mitsuhiro Shibayama, Toyoichi Tanaka, Charles C Han,
+*J. Chem. Phys.* 1992, 97 (9), 6829-6841
 
 Simon Mallam, Ferenc Horkay, Anne-Marie Hecht, Adrian R Rennie, Erik Geissler,
-Macromolecules 1991, 24, 543-548
+*Macromolecules* 1991, 24, 543-548
 
 """
@@ -62,4 +62,5 @@
 category = "shape-independent"
 
+# pylint: disable=bad-whitespace, line-too-long
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["guinier_scale",    "cm^{-1}",   1.7, [-inf, inf], "", "Guinier length scale"],
@@ -68,6 +69,6 @@
               ["fractal_exp",      "",          2.0, [0, inf],    "", "Fractal exponent"],
               ["cor_length",       "Ang",      16.0, [0, inf],    "", "Correlation length"]
-              ]
-
+             ]
+# pylint: enable=bad-whitespace, line-too-long
 
 source = ["gel_fit.c"]
@@ -92,5 +93,5 @@
            'fractal_exp': 10.0,
            'cor_length': 20.0
-           }, 0.1, 0.716532],
+          }, 0.1, 0.716532],
 
          [{'guinier_scale': 4.0,
@@ -100,5 +101,4 @@
            'cor_length': 20.0,
            'background': 20.0,
-           }, 5.0, 20.1224653026],
-
-         ]
+          }, 5.0, 20.1224653026],
+        ]
Index: sasmodels/models/hardsphere.py
===================================================================
--- sasmodels/models/hardsphere.py	(revision 7ed702f2d0d4ecbcb0115970cdabf0d05ac08de0)
+++ sasmodels/models/hardsphere.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -55,4 +55,5 @@
                "volume fraction of hard spheres"],
              ]
+single = False
 
 # No volume normalization despite having a volume parameter
@@ -106,2 +107,7 @@
 oldpars = dict()
 
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'effect_radius' : 50.0, 'volfraction' : 0.2,
+           'effect_radius_pd' : 0}, [0.001], [0.209128]]
+        ]
+
Index: sasmodels/models/lamellarCaille.py
===================================================================
--- sasmodels/models/lamellarCaille.py	(revision d18f8a8e10d65f0ace6fdc9360abd60dfcd6dcce)
+++ sasmodels/models/lamellarCaille.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -87,4 +87,6 @@
 category = "shape:lamellae"
 
+single = False
+
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["thickness", "Ang",  30.0, [0, inf], "volume", "sheet thickness"],
@@ -122,2 +124,8 @@
 oldpars = dict(thickness='delta', Nlayers='N_plates', Caille_parameter='caille',
                sld='sld_bi',solvent_sld='sld_sol')
+#
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'thickness' : 30.,'Nlayers' : 20.0, 'spacing' : 400.,
+            'Caille_parameter' : 0.1, 'sld' : 6.3, 'solvent_sld' : 1.0,
+            'thickness_pd' : 0.0, 'spacing_pd' : 0.0 }, [0.001], [28895.13397]]
+        ]
